# HG changeset patch
# User John D
# Date 1486799431 18000
#      Sat Feb 11 02:50:31 2017 -0500
# Node ID 919c2981db2043845ecea1f0284945139fbb1691
# Parent  8bf7d78a7746d1af40db679b27559c092aebea21
gcc: update to 6.3.0

* src/build-gcc.mk: update version 6.3.0

* src/cloog.mk: update 0.18.4

* src/gmp.mk: update 6.1.2

* src/isl.mk: update 0.16.1, add no-undefined flag

* src/mpfr.mk: update 3.1.6

* src/native-gcc.mk: update 6.3.0

* src/isl-1-fixes.patch: removed file

* changed dist-files.mk: remove reference to isl-1-fixes.patch

diff -r 8bf7d78a7746 -r 919c2981db20 dist-files.mk
--- a/dist-files.mk	Sun Feb 05 07:12:24 2017 -0500
+++ b/dist-files.mk	Sat Feb 11 02:50:31 2017 -0500
@@ -181,7 +181,6 @@
   imagemagick.mk \
   inputproto.mk \
   intltool.mk \
-  isl-1-fixes.patch \
   isl.mk \
   itsol.mk \
   itstool.mk \
diff -r 8bf7d78a7746 -r 919c2981db20 src/build-gcc.mk
--- a/src/build-gcc.mk	Sun Feb 05 07:12:24 2017 -0500
+++ b/src/build-gcc.mk	Sat Feb 11 02:50:31 2017 -0500
@@ -3,8 +3,8 @@
 
 PKG             := build-gcc
 $(PKG)_IGNORE   :=
-$(PKG)_VERSION  := 4.9.4
-$(PKG)_CHECKSUM := 5bb0b783a57a62b11f1f9bd2aa37145da221d3d0
+$(PKG)_VERSION  := 6.3.0
+$(PKG)_CHECKSUM := 928ab552666ee08eed645ff20ceb49d139205dea
 $(PKG)_SUBDIR   := gcc-$($(PKG)_VERSION)
 $(PKG)_FILE     := gcc-$($(PKG)_VERSION).tar.bz2
 $(PKG)_URL      := ftp://ftp.gnu.org/pub/gnu/gcc/gcc-$($(PKG)_VERSION)/$($(PKG)_FILE)
diff -r 8bf7d78a7746 -r 919c2981db20 src/cloog.mk
--- a/src/cloog.mk	Sun Feb 05 07:12:24 2017 -0500
+++ b/src/cloog.mk	Sat Feb 11 02:50:31 2017 -0500
@@ -3,8 +3,8 @@
 
 PKG             := cloog
 $(PKG)_IGNORE   :=
-$(PKG)_VERSION  := 0.18.1
-$(PKG)_CHECKSUM := 2dc70313e8e2c6610b856d627bce9c9c3f848077
+$(PKG)_VERSION  := 0.18.4
+$(PKG)_CHECKSUM := 8f7568ca1873f8d55bb694c8b9b83f7f4c6c1aa5
 $(PKG)_SUBDIR   := $(PKG)-$($(PKG)_VERSION)
 $(PKG)_FILE     := $(PKG)-$($(PKG)_VERSION).tar.gz
 $(PKG)_URL      := ftp://gcc.gnu.org/pub/gcc/infrastructure/$($(PKG)_FILE)
diff -r 8bf7d78a7746 -r 919c2981db20 src/gmp.mk
--- a/src/gmp.mk	Sun Feb 05 07:12:24 2017 -0500
+++ b/src/gmp.mk	Sat Feb 11 02:50:31 2017 -0500
@@ -3,8 +3,8 @@
 
 PKG             := gmp
 $(PKG)_IGNORE   :=
-$(PKG)_VERSION  := 6.1.1
-$(PKG)_CHECKSUM := 757d672e66d8e0afe60ca04735ab11c00d9346e4
+$(PKG)_VERSION  := 6.1.2
+$(PKG)_CHECKSUM := 366ded6a44cd108ba6b3f5b9a252eab3f3a95cdf
 $(PKG)_SUBDIR   := $(PKG)-$($(PKG)_VERSION)
 $(PKG)_FILE     := $(PKG)-$($(PKG)_VERSION).tar.bz2
 $(PKG)_URL      := https://gmplib.org/download/gmp/$($(PKG)_FILE)
diff -r 8bf7d78a7746 -r 919c2981db20 src/isl-1-fixes.patch
--- a/src/isl-1-fixes.patch	Sun Feb 05 07:12:24 2017 -0500
+++ /dev/null	Thu Jan 01 00:00:00 1970 +0000
@@ -1,36 +0,0 @@
-diff -ur a/include/isl/int.h b/include/isl/int.h
---- a/include/isl/int.h	2012-11-29 03:47:32.000000000 -0500
-+++ b/include/isl/int.h	2014-02-19 02:44:04.311137242 -0500
-@@ -14,7 +14,7 @@
- #include <string.h>
- #include <gmp.h>
- #if defined(__cplusplus)
--#include <iostream>
-+#include <ostream>
- #endif
- 
- #if defined(__cplusplus)
-diff -u isl-0.12.2.orig/Makefile.am isl-0.12.2/Makefile.am
---- isl-0.12.2.orig/Makefile.am	2014-04-25 14:38:30.985118233 -0400
-+++ isl-0.12.2/Makefile.am	2014-04-25 14:39:56.860765352 -0400
-@@ -154,7 +154,7 @@
- 	isl_sample_piplib.h \
- 	isl_piplib.c
- libisl_la_LIBADD = @PIPLIB_LIBS@ @GMP_LIBS@
--libisl_la_LDFLAGS = -version-info @versioninfo@ \
-+libisl_la_LDFLAGS = -no-undefined -version-info @versioninfo@ \
- 	@PIPLIB_LDFLAGS@ @GMP_LDFLAGS@
- libisl_la_CPPFLAGS = $(INCLUDES) @PIPLIB_CPPFLAGS@ @GMP_CPPFLAGS@
- 
-diff -u isl-0.12.2.orig/Makefile.in isl-0.12.2/Makefile.in
---- isl-0.12.2.orig/Makefile.in	2014-04-25 14:38:30.972117984 -0400
-+++ isl-0.12.2/Makefile.in	2014-04-25 14:40:36.809531647 -0400
-@@ -645,7 +645,7 @@
- 	isl_piplib.c
- 
- libisl_la_LIBADD = @PIPLIB_LIBS@ @GMP_LIBS@
--libisl_la_LDFLAGS = -version-info @versioninfo@ \
-+libisl_la_LDFLAGS = -no-undefined -version-info @versioninfo@ \
- 	@PIPLIB_LDFLAGS@ @GMP_LDFLAGS@
- 
- libisl_la_CPPFLAGS = $(INCLUDES) @PIPLIB_CPPFLAGS@ @GMP_CPPFLAGS@
diff -r 8bf7d78a7746 -r 919c2981db20 src/isl.mk
--- a/src/isl.mk	Sun Feb 05 07:12:24 2017 -0500
+++ b/src/isl.mk	Sat Feb 11 02:50:31 2017 -0500
@@ -3,13 +3,15 @@
 
 PKG             := isl
 $(PKG)_IGNORE   :=
-$(PKG)_VERSION  := 0.12.2
-$(PKG)_CHECKSUM := ca98a91e35fb3ded10d080342065919764d6f928
+$(PKG)_VERSION  := 0.16.1
+$(PKG)_CHECKSUM := c5a2b201bf05229647e73203c0bf2d9679d4d21f
 $(PKG)_SUBDIR   := $(PKG)-$($(PKG)_VERSION)
 $(PKG)_FILE     := $(PKG)-$($(PKG)_VERSION).tar.bz2
 $(PKG)_URL      := ftp://gcc.gnu.org/pub/gcc/infrastructure/$($(PKG)_FILE)
 $(PKG)_DEPS     := build-gcc gmp
 
+$(PKG)_EXTRA_MAKE_FLAGS := LDFLAGS='-no-undefined'
+
 # stick to tested versions from gcc
 define $(PKG)_UPDATE
     $(WGET) -q -O- 'ftp://gcc.gnu.org/pub/gcc/infrastructure/' | \
diff -r 8bf7d78a7746 -r 919c2981db20 src/mpfr.mk
--- a/src/mpfr.mk	Sun Feb 05 07:12:24 2017 -0500
+++ b/src/mpfr.mk	Sat Feb 11 02:50:31 2017 -0500
@@ -3,8 +3,8 @@
 
 PKG             := mpfr
 $(PKG)_IGNORE   :=
-$(PKG)_VERSION  := 3.1.4
-$(PKG)_CHECKSUM := cedc0055d55b6ee4cd17e1e6119ed412520ff81a
+$(PKG)_VERSION  := 3.1.5
+$(PKG)_CHECKSUM := c0fab77c6da4cb710c81cc04092fb9bea11a9403
 $(PKG)_SUBDIR   := $(PKG)-$($(PKG)_VERSION)
 $(PKG)_FILE     := $(PKG)-$($(PKG)_VERSION).tar.xz
 $(PKG)_URL      := ftp://ftp.gnu.org/pub/gnu/$(PKG)/$($(PKG)_FILE)
diff -r 8bf7d78a7746 -r 919c2981db20 src/native-gcc.mk
--- a/src/native-gcc.mk	Sun Feb 05 07:12:24 2017 -0500
+++ b/src/native-gcc.mk	Sat Feb 11 02:50:31 2017 -0500
@@ -3,8 +3,8 @@
 
 PKG             := native-gcc
 $(PKG)_IGNORE   :=
-$(PKG)_VERSION  := 4.9.4
-$(PKG)_CHECKSUM := 5bb0b783a57a62b11f1f9bd2aa37145da221d3d0
+$(PKG)_VERSION  := 6.3.0
+$(PKG)_CHECKSUM := 928ab552666ee08eed645ff20ceb49d139205dea
 $(PKG)_SUBDIR   := gcc-$($(PKG)_VERSION)
 $(PKG)_FILE     := gcc-$($(PKG)_VERSION).tar.bz2
 $(PKG)_URL      := ftp://ftp.gnu.org/pub/gnu/gcc/gcc-$($(PKG)_VERSION)/$($(PKG)_FILE)